<?php
/**
 *  SpeedBar
 *
 * @link http://fdcore.ru
 *
 * @author NetSoul
 */
$plugin_info = array(
						'pi_name'			=> 'SpeedBar',
						'pi_version'		=> '1.0',
						'pi_author'			=> 'FDCore Studio',
						'pi_author_url'		=> 'http://fdcore.ru/',
						'pi_description'	=> 'Speed bar on you site',
						'pi_usage'			=> Speedbar::usage()
					);
class Speedbar {

    var $return_data;
    var $homepage;
    var $weblog_id;
    var $entry_id;
    var $link=array();
    
    function Speedbar()
    {
    	global $TMPL, $FNS, $DB, $IN;
    	$delimer = ( ! $TMPL->fetch_param('delimer')) ? '>' :  $TMPL->fetch_param('delimer');
    	$show = ( ! $TMPL->fetch_param('show')) ? 'homepage|weblog|cat|entry' :  $TMPL->fetch_param('show');
    	$need_show=explode('|',$show );
		$link=array();
		$this->_get_homepage();
		if(isset($IN->QSTR)){
			$entry_id = $IN->QSTR;
		} else $entry_id=0;
		
		if ( ! $template_group = $IN->fetch_uri_segment('1'))
		{
		    $template_group=$this->homepage;
		}
    	if(count($IN->SEGS)>1) 		$this->_get_entry($entry_id,$template_group);
    	if(count($IN->SEGS)>1) 		$this->_get_cat();
      if(count($IN->SEGS)>1)		if(count($IN->SEGS)>1) $this->_get_blog();
      
      foreach ($need_show as $value) {
      	if(isset($this->link[$value])) $this->return_data.=$this->link[$value]." $delimer ";
      }
      $strmin=strlen($delimer)+2;
      $this->return_data=substr($this->return_data,0,-$strmin);
    }
    
    
    /**
     *  
     *
     * @param string $id 
     * @return void
     * @author NetSoul
     */
    function _get_entry($id,$tpl)
    {
    	global $DB;
    	if($id=='') return false;
    	if(is_numeric($id)) $query = $DB->query("SELECT * FROM exp_weblog_titles WHERE entry_id=$id"); else
		$query = $DB->query("SELECT * FROM exp_weblog_titles WHERE url_title='$id'");
		if ($query->num_rows > 0)
		{
			foreach($query->result as $row)
			{
				$title=$row['title'];
				$this->weblog_id=$row['weblog_id'];
				$this->entry_id=$row['entry_id'];
			}
			$hp=$this->homepage;
			if($title!='') $this->link['entry']="<a href='$hp/$tpl/$id'>$title</a>";
		}//num_wors
    }
    
    /**
     *      
     *
     * @return void
     * @author NetSoul
     */
    function _get_homepage()
    {
    	global $DB;
    	
	 	$query = $DB->query("SELECT * FROM exp_sites WHERE site_id=1");
	
	    foreach($query->result as $row)
	    {
	      $homepage_name = $row['site_label'];
	      $homepage_u= unserialize($row['site_system_preferences']);
	      $homepage_url=$homepage_u['site_url'];
	    }
	    $this->homepage=$homepage_url.'index.php';
	    $this->link['homepage']= "<a href='$homepage_url'>$homepage_name</a>";
    }

    /**
     *   
     *
     * @return void
     * @author NetSoul
     */
    function _get_blog()
    {
		global $DB;
		$id=$this->weblog_id;
		if(!is_null($id)){
		$query = $DB->query("SELECT * FROM exp_weblogs WHERE weblog_id=$id");
		if ($query->num_rows > 0)
		{
			foreach($query->result as $row)
			{
				$title		=	$row['blog_title'];
				$blog_url	=	$row['blog_url'];
				$blog_description	=	$row['blog_description'];
			}//for
			$this->link['weblog']= "<a href='$blog_url' title='$blog_description'>$title</a>";
		}//num_rows
	}//is_null
    }

	function _get_cat()
    {
		global $DB;
		$next=TRUE;
		$id=$this->entry_id;
		if($id=='') return false;
		$query = $DB->query("SELECT cat_id FROM exp_category_posts WHERE entry_id=$id");
		if ($query->num_rows > 0)
		{
			foreach($query->result as $row)
			{
				$cat_id		=	$row['cat_id'];
			}//for
			$next=true;
		} else $next=FALSE;
		
		if($next){
			$query = $DB->query("SELECT cat_name, cat_url_title,cat_description FROM exp_categories WHERE cat_id=$cat_id");
			if ($query->num_rows > 0)
			{
				foreach($query->result as $row)
				{
					$cat_name		=	$row['cat_name'];
					$cat_url_title	=	$row['cat_url_title'];
					$cat_description	=	$row['cat_description'];
				}//for
				$hp=$this->homepage;
				$this->link['cat']= "<a href='$hp/C$cat_id' title='$cat_description'>$cat_name</a>";
			}			
		}
    }    
    
	function usage()
	{
	ob_start(); 
	?>
	     (   )
	
	{exp:speedbar delimer=">"}
	
	:
	delimer -    
	show -      ,  homepage|weblog|cat|entry  (show="weblog|entry")
	<?php
	$buffer = ob_get_contents();
		
	ob_end_clean(); 
	
	return $buffer;
	}    
}

?>